% function definition for Rasmussen's minimise()
% fv  = function value
% dfv = gradient of the fucntion w.r.t W
% wk is unused 

function [fv dfv] = gradws(w, gamma, x, y, mask, regFunc, lambda, sn)

CLS    = size(gamma, 2);
DIM    = size(x, 2);

% compute regularisation term with smoothing approx at 0
%reg    = sum(sum(lambda.*(sqrt(w.^2 + sn))));

% compute regularisation term 
[regV regDV] = regFunc(w, sn);

reg    = sum(sum(lambda.*regV));

w      = reshape(w, DIM, CLS);
lambda = reshape(lambda, DIM, CLS);
regDV  = reshape(regDV, DIM, CLS);

% calculate function value
sk     = posteriorYHat(x, w, gamma);    
fv     = -sum(log(sk(mask)), 1) + reg;


% faster way
tmpw   = zeros(DIM, CLS); 
logit  = softmax(x * w);

for c = 1:CLS 
    
    % calculate logit w.r.t to w_c and repmat to match sk
    logit_c = repmat(logit(:,c), 1, CLS);
    
    % calculate the big chunk in parentheses
    gc      = repmat(gamma(c,:), CLS, 1);
    gc      = gc - gamma;    
    chunk   = logit * gc;
    
    % calculate multiplier to X
    multi   = (logit_c .* chunk) ./ sk ;
    
    % multiply with X
    llhw    = zeros(1, DIM); 
    
    for k = 1:CLS
        res   = repmat(multi(:,k), 1, DIM) .* x;
        llhw  = llhw - sum(res(y==k,:), 1);
    end
    
    % save the derivative of w_c
    tmpw(:,c) = llhw';
end

% compute derivative of regularisation term with smoothing hack at 0
%reg  = lambda .* (w./(sqrt(w.^2+sn)));
%tmpw = tmpw + reg;
tmpw = tmpw + (lambda .* regDV);
dfv  = cat(2,tmpw(:));

 