function [Yz FD] = injectLabelNoise(Y, FD, NoiseType, FLIPP)

% work out number of class
CLS = size(unique(Y),1);

Yz  = Y;

% randomly select instances to be flipped
if (strcmp(NoiseType,'sym'))
    noise          = rand(size(Y));
    index          = find(noise < FLIPP/CLS);
else
%     for c=1:CLS
%         cnt(c) = sum(Y==c);
%     end
    tc             = randi(CLS);
    %[d tc]         = max(cnt);
    noise          = ones(size(Y));
    noise(Y == tc) = rand(sum(Y == tc),1);
    index          = find(Y == tc & noise < FLIPP);
end

% mark those instances as flipped
FD(index) = 1;

% injecting the noise
noise     = randi([1 (CLS-1)], size(index));
Yz(index) = Yz(index) + noise;  
index     = (Yz > CLS);         
Yz(index) = mod(Yz(index),CLS); 